$FIELD = 1;
sub field_init{
    %FieldAlias = ('author' => 'from',
                   'title' => 'subject',
                   'url' => 'uri',
                   );
}
&field_init;

sub field_search{
    local($origkey, *score, $_) = @_;
    s/\xa0/ /g;
    my $key = $_;
    my($flag, $match, $pat);
    local(*FH, *FDAT, *FNDX);

    $key =~ s/^\+([^\:\s]+)\://;
    my($field) = $1;
    $field =~ tr/A-Z/a-z/;

    if ($key =~ s/^\/(.*)\/$/$1/){
        my %opt = ('ex' => 1, 'case' => 0, 'ff' => 1);
        $pat = &regconv(\$key, \%opt);
        $flag = $opt{'MB'};

        $match = "+$field:/$key/";
        $key = "/$key/";
        eval("/$pat/i");
        s/[\r\n]//g, s/ at .*//, push(@DbErrors, "$match $_"), return ($match, '', 0) if $_ = $@;
    }else{
        ($pat = $key) =~ s/^\"(.*)\"$/$1/; #"
        $pat = &quote_meta($pat);
        $match = "+$field:$key";
    }

    if ($CACHE){
        &cache_init;
        $totalhit = &cache_read_score("field $field $pat", *score);
        if ($totalhit >= 0){
            $score{'field_r'} = $score{'field_l'} = 1;
            return ($match, '', $totalhit);
        }
        $totalhit = 0;
    }

    my $alias = $field;
    my $ext;
    while (1){
        $ext = 'qfield';
        last if open(FH, "$DbPath.$ext.$alias") && open(FDAT, "$DbPath.$ext.$alias.f") && open(FNDX, "$DbPath.$ext.$alias.fi");

        $ext = 'field';
        last if open(FH, "$DbPath.$ext.$alias");

        push(@DbErrors, "$match: unknown field"), return ($match, '', 0) if !$FieldAlias{$alias};
        $alias = $FieldAlias{$alias};
    }

    my($ndx, $totalhit) = (0, 0);
    my($tmp, $str, $offset);

    my $searchstr = "while(defined(\$str = <FH>)){\n";
    $searchstr .= "&replace(\$str);\n" if $alias =~ /ur[li]/i && $Replace;
    $searchstr .= "\$str =~ s/([\\xa1-\\xfe].)/\\xff\$1/g;\n" if $flag;

    $searchstr .= "if (\$str =~ /$pat/i){\n";
    if ($ext eq 'qfield'){
        $searchstr .= "seek(FNDX, \$ndx * $IntSize, 0);\n";
        $searchstr .= "read(FNDX, \$tmp, $IntSize * 2);\n";
        $searchstr .= "(\$offset, \$tmp) = unpack('$IntNType*', \$tmp);\n";
        $searchstr .= "seek(FDAT, \$offset, 0);\n";
        $searchstr .= "read(FDAT, \$tmp, \$tmp - \$offset);\n";

        $searchstr .= "\$offset = 0;\n";
        $searchstr .= "foreach \$tmp (&unpackw(\$tmp)){";
        $searchstr .= "\$offset += \$tmp;";
        $searchstr .= "\$totalhit++, \$score{\$offset} = -1 if !\$score{\$offset} && &TimEnable(\$offset)";
        $searchstr .= "}";
    }else{
        $searchstr .= "\$totalhit++, \$score{\$ndx} = -1 if &TimEnable(\$ndx);\n";
    }
    $searchstr .= "last if \$totalhit >= \$MaxFieldHit;\n" if $MaxFieldHit;
    $searchstr .= "}";
    $searchstr .= "\$ndx++;\n";
    $searchstr .= "}";
    eval $searchstr;
    close FH;
    close FDAT;
    close FNDX;

    if ($MaxFieldHit && $totalhit >= $MaxFieldHit){
        $totalhit = 0;
        %score = ('TooMany' => $Text{'hit'});
    }else{
        &cache_write_score("field $field $pat", *score) if $CACHE;
    }

    $score{'field_r'} = $score{'field_l'} = 1;
    return ($match, '', $totalhit);
}
1;
