#---------------------- 'hash operation' Module ----------------------
$hashop::HashName = 'hash0';

sub makehash{
    ++$hashop::HashName;
    %$hashop::HashName = ();
    return \%$hashop::HashName;
}

sub op_score{
    my($x, $y, $or) = @_;
    return $y unless $x;
    return $x unless $y;
    return $y if $x == -1;
    return $x if $y == -1;
    return $x if ($x <=> $y) == $or;
    $y;
}

sub opDefault{
    my ($x, $y, $p, $r) = @_;
    if ($p && $DbSize{'PHRASE'}){
        &opPhrase($x, $y, $KPMode && $r && grep {$_ eq "\xa1\xa6 \xa1\xa6\n"} values %{$y->{'phrase'}});
    }elsif ($OpMode eq 'or' and !$p){
        &opOr($x, $y);
    }else{
        &opAnd($x, $y);
    }
}

sub opAnd{
    my ($x, $y) = @_;
    return if $y->{'Disable'} || $y->{'TooMany'};
    %$x = %$y, return if $x->{'Disable'} || $x->{'TooMany'};

    $x->{'field_l'} = 1 if $y->{'field_l'};
    $x->{'field_r'} = 1 if $y->{'field_r'};

    delete $x->{'phrase'} if my $f = ($x->{'field_l'} && $x->{'field_r'});
    my $key;
    my @key = keys %$x;

    for $key (@key){
        next if $key =~ /phrase|field_/;
        my $vx = $x->{$key};
        if (my $vy = $y->{$key}){
            $x->{$key} = &op_score($vx, $vy);
            $x->{'phrase'}{$key} .= $y->{'phrase'}{$key} unless $f;
        }else{
            delete $x->{$key};
            delete $x->{'phrase'}{$key};
        }
    }
}

sub opPhrase{
    my ($x, $y, $orop) = @_;

    return if $y->{'Disable'} || $y->{'TooMany'};
    %$x = %$y, return if $x->{'Disable'} || $x->{'TooMany'};

    delete $x->{'phrase'} if my $f = ($x->{'field_l'} && $y->{'field_r'});
    my($key, $px, $py);
    my @key = keys %$x;
    for $key (@key){
        next if $key =~ /phrase|field_/;
        my $vx = $x->{$key};

        my $score = 0;
        my $phrase = $orop? $x->{'phrase'}{$key}: '';
        if (my $vy = $y->{$key}){
            $score = &op_score($vx, $vy);

            if ($x->{'field_r'} || $y->{'field_l'}){
                delete $x->{'phrase'}{$key} if $x->{'field_l'};
                $x->{'phrase'}{$key} .= $y->{'phrase'}{$key} unless $y->{'field_r'};
                $x->{$key} = $score;
                next;
            }
            for $px (split("\n", $x->{'phrase'}{$key})){
                my ($px1, $px2) = split(' ', $px);
                for $py (split("\n", $y->{'phrase'}{$key})){
                    my ($py1, $py2) = split(' ', $py);

                    my $s = $px2 . $py1;
                    &PhraseList($s) if !$Phrase{$s};
                    $phrase .= "$px1 $py2\n", next if $Phrase{$s}{$key};
                    if ($TinyMknmz){
                        # tiny_mknmz Ǥʸΰ㤦ե졼Ͽ
                        # ƤʤΤǡ̵ҥåȤȤ
                        my $ox = ord $px2;
                        $ox = (0xb0 <= $ox) + (0xa1 <= $ox);
                        my $oy = ord $py1;
                        $oy = (0xb0 <= $oy) + (0xa1 <= $oy);
                        $phrase .= "$px1 $py2\n" if $ox != $oy;
                    }
                }
            }
            if ($phrase){
                $x->{$key} = $score;
                $x->{'phrase'}{$key} = $phrase unless $f;
            }
        }
        unless ($phrase){
            delete $x->{$key};
            delete $x->{'phrase'}{$key};
        }
    }
    delete $x->{'field_r'};
    $x->{'field_r'} = 1 if $y->{'field_r'};
}

sub opNot{
    my ($x, $y) = @_;
    return if $x->{'Disable'} || $x->{'TooMany'};

    my $key;
    my @key = keys %$x;
    for $key (@key){
        next if $key =~ /phrase|field_/;
        if ($y->{$key}){
            delete $x->{$key};
            delete $x->{'phrase'}{$key};
        }
    }
}

sub opOr{
    my ($x, $y) = @_;

    return if $y->{'Disable'} || $y->{'TooMany'};
    %$x = %$y, return if $x->{'Disable'} || $x->{'TooMany'};

    $x->{'field_l'} = 1 if $y->{'field_l'};
    $x->{'field_r'} = 1 if $y->{'field_r'};

    delete $x->{'phrase'} if my $f = ($x->{'field_l'} && $x->{'field_r'});
    my $key;
    my @key = keys %$y;
    for $key (@key){
        next if $key =~ /phrase|field_/;

        $x->{$key} = &op_score($x->{$key}, $y->{$key}, 1);
        $x->{'phrase'}{$key} .= $y->{'phrase'}{$key} unless $f;
    }
}

sub opMinus{
    my ($x, $y) = @_;
    return if $x->{'Disable'} || $x->{'TooMany'};

    my $key;
    my @key = keys %$x;
    for $key (@key){
        next if $key =~ /phrase|field_/;

        my $phrase = '';
        if ($y->{$key}){
            my $w;
            my @y = split("\n", $y->{'phrase'}{$key});
            for $w (split("\n", $x->{'phrase'}{$key})){
                $phrase .= "$w\n" unless grep {$_ eq $w} @y;
            }
            if ($phrase){
                $x->{'phrase'}{$key} = $phrase;
            }else{
                delete $x->{$key};
                delete $x->{'phrase'}{$key};
            }
        }
    }
}
1;
#------------------ End of 'hash operation' Module -------------------
