$TSEARCH = 1;

sub tsearch_init{
    # gmtime Ȥλη׻
    my ($sec, $min, $hour, $mday, $mon) = localtime(0);
    $TDif = (($hour * 60) + $min) * 60 + $sec;
    $TDif -= 24 * 60 * 60 if $mon;

    $TMax = (~0) >> 1;
    $Today = &ymd2time(&time2ymd($^T + $TDif));
}
&tsearch_init;

sub tsearch{
    local($origkey, *score, $_) = @_;
    my $key = $_;
    my ($match, $db) = ('+[', "$DbPath.t");
    my($r0, $r1);
    my($fileno, $totalhit) = (0, 0);

    $key =~ s/^\+\[//;
    $key =~ s/\].*//;
    my ($x, $y) = split(/,/, $key);

    if ($x ne ''){
        ($r0, $r1) = &calc_time(1, $x, 0);
        ($r0, $r1) = &calc_time(0, $y, $r0) if $y ne '';
        $r1 = $TMax if ($key =~ /,/) && $y eq '';
    }elsif ($y){
        $r0 = 0;
        $r1 = &calc_time(0, $y, 0);
    }elsif ($key =~ /,/){
        $r1 = $TMax;
    }
    my $str0 = sprintf("%4d.%02d.%02d", &time2ymd($r0));
    my $str1 = sprintf("%4d.%02d.%02d", &time2ymd(&add_time(0, 0, -1, $r1)));
    $match .= $str0 if $r0;
    if ($r1 == $TMax){
        $match .= ',';
    }elsif ($str0 ne $str1){
        $match .= ",$str1";
    }
    $match .= ']';

    $r0 = &fixtdif($r0);
    $r1 = &fixtdif($r1);

    if ($CACHE){
        &cache_init;
        $totalhit = &cache_read_score("tim $match", *score);
        if ($totalhit >= 0){
            $score{'field_r'} = $score{'field_l'} = 1;
            return ($match, '', $totalhit);
        }
        $totalhit = 0;
    }

    while ($fileno < $DbNdx{'TIM'}){
        my $t = &indexpointer('TIM', $fileno);
        $totalhit++, $score{$fileno} = -1 if $r0 < $t && $t < $r1 && &TimEnable($fileno);
        last if $MaxFieldHit && $totalhit >= $MaxFieldHit;
        $fileno++;
    }
    if ($MaxFieldHit && $totalhit >= $MaxFieldHit){
        $totalhit = 0;
        %score = ('TooMany' => $Text{'hit'});
    }else{
        &cache_write_score("tim $match", *score) if $CACHE;
    }
    $score{'field_r'} = $score{'field_l'} = 1;
    return ($match, '', $totalhit);
}

sub calc_time{
    my($isx, $t, $z) = @_;
    my $sgn = ($t =~ s/^([\+\-])//)? $1: '';
    my ($y, $m, $d) = split(/\./, $t);
    my ($r0, $r1);

    $sgn = '-' if $sgn && !$z;

    if ($sgn eq '+'){
        return ($z, &add_time($y, $m, $d, $z));
    }elsif ($sgn eq '-'){
        return (&add_time(-$y, -$m, -$d, $Today), $TMax) if $isx;
        return ($z, &add_time(-$y, -$m, -$d, $Today));
    }
    my($yy, $mm, $dd) = &time2ymd($Today);
    if ($y ne ''){
        $y += 1900 if $y < 100;
        $y += 100 if $y < 1970;
        $yy = $y, $mm = 1, $dd = 1;
    }
    if ($m =~ /[a-z]/i){
        my $ndx = 12;
        --$ndx while $ndx && ('january', 'february', 'march', 'april',
                              'may', 'june','july', 'august',
                              'september', 'october', 'november',
                              'december')[$ndx - 1] !~ /^$m/i;
        $m = $ndx;
    }
    $mm = $m, $dd = 1 if $m;
    $dd = $d if $d;

    $r0 = &ymd2time($yy, $mm, $dd);

    # +[] 򸡺δַ׻
    ($r1) = &add_time(!$d && !$m, !($d || !$m), $d && 1, $r0);

    if ($y || $m){
        # άˡ̷Τʤ褦ˤ
        $y = ($m && !$y);
        $m = !$m;
        if ($isx){
            ($r0, $r1) = &add_time(-$y, -$m, 0, $r0, $r1) if $Today < $r0;
        }elsif ($r1 < ($r0 = $z)){
            $r1 = &add_time($y, $m, 0, $r1);
        }
    }
    ($r0, $r1);
}

sub add_time{
    # time  ($year, $mon, $mday) û
    my($dy, $dm, $dd, @t) = @_;
    my @ret;
    my $t;

    for $t (@t){
        my($y, $m, $d) = &time2ymd($t);
        $y += $dy;
        $m += $dm;
        ++$y, $m -= 12 while $m > 12 && $y <= 2038;
        --$y, $m += 12 while $m < 1 && $y >= 1970;
        push(@ret, &ymd2time($y, $m, $d) + $dd * 60 * 60 * 24);
    }
    @ret;
}

sub time2ymd{
    # time  ($year, $mon, $mday) Ѵ롣
    # $year ϡ 4 $mon  1-12 Ȥ
    
    my ($sec, $min, $hour, $mday, $mon, $year) = gmtime(shift);
    ($year + (($year < 70)? 2000: 1900), ++$mon, $mday);
}

sub ymd2time{
    # ($year, $mon, $mday)  time Ѵ롣
    my ($year, $mon, $mday) = @_;
    my @mday = (31, 28 + !($year % 4), 31, 30, 31, 30, 31, 31, 30, 31, 30);
    $mday += $mday[$mon - 1] while --$mon > 0;

    $year -= 1970;
    # perl λϰϤǤϡñˡǯ 4 ǯ 1 ٤Ǥ褤
    $mday += (365 * 4 + 1) * int($year / 4);
    $year %= 4;
    $mday += 365 * $year + ($year == 3);
    my $t = ($mday - 1) * 24 * 60 * 60;
    return 0 if $t < 0;
    return $TMax if $t > $TMax;
    $t;
}

sub fixtdif{
    my $t = shift;
    return 0 if $t <= 0;
    return $TMax if $t >= $TMax;
    $t -= $TDif;
    return 0 if $t <= 0;
    return $TMax if $t >= $TMax;
    $t;
}
1;
