#! /usr/local/bin/perl
# -*- Perl -*-
#
# fpwnmz.pl - by furukawa@tcp-ip.or.jp
#

# ޤ̣Ȥϻפޤ󤬡
# ǥå򼭽Ѵ륹ץȤǤ
# FreePWing Ѥޤ
# Makefile ¾ϡŬѰդƤ

sub judge{
    # Υ֥롼ˤơθ򸡺˴ޤ뤫ɤޤ
    # ֤ȡθ򸡺˴ޤޤ

    # 褤פĤ顢˵ҤƤ
    # ĤȤ˶Ƥ

    my $word = shift;
    my $hit = shift;

    # Ȥꤢߤξϡ

    # Ĺ 100 ʸʲġҥåȿ 2 ʾ 100 ʲ
    return 0 if 100 < length $word;
    return 0 if $hit < 2 or 100 < $hit;

    # ե٥å 3 ʸʾޤϡ 2 ʸʾ
    return 1 if $word =~ /^[a-z]{3,}$/;
    return 1 if $word =~ /^([\xb0-\xfe].){2,}$/;
    return 1 if $word =~ /^\xa5.(\xa5.|\xa1\xbc)+$/;

    return 0;
}

use strict;
use English;

use FileHandle;
use FreePWING::FPWUtils::FPWParser;

{
    my($tmp) = $0;
    $tmp = "./$tmp" if $tmp !~ /[\/\\]/;
    while ($tmp =~ /^(.*[\/\\])/){
        unshift(@INC, $1);
        last if !-l $tmp;
        $tmp = $1 . $tmp if ($tmp = readlink($tmp)) !~ /^\//;
    }
}
require 'nmzidx.pl';

my $dir = shift(@ARGV);

my %keyword;

my $nmz = new nmzidx($dir, 'r');
my $nmz_word = $nmz->open_word;
{
    my $word;
    my %list;
    my $ndx = 0;
    while (defined $nmz_word->read(\$word, \%list)){
        if (&judge($word, scalar keys %list)){
            for my $key (keys %list){
                push(@{$keyword{$key}}, $word);
            }
            print "$ndx: $word\n" unless ++$ndx % 100;
        }
    }
}

my $fpwtext;
my $fpwheading;
my $fpwword2;
my $fpwmenu;
my $fpwcopyright;

#
# ƽϥե򳫤
#
initialize_fpwparser('text' => \$fpwtext,
		     'heading' => \$fpwheading,
		     'word2' => \$fpwword2);

my $nmz_flist = $nmz->open_flist;
{
    my $file_no = 0;
    my $size = $nmz_flist->{'size'};
    my %list;
    while (defined $nmz_flist->read(\%list)){
        $fpwtext->new_entry() or &fpw_abort($fpwtext, 'new_entry');
        $fpwheading->new_entry() or &fpw_abort($fpwheading, 'new_entry');

        #ν񤭹
        my $text_position = $fpwtext->entry_position();
        my $heading_position = $fpwheading->entry_position();
        for my $word (@{$keyword{$file_no}}){
            $fpwword2->add_entry($word, $heading_position,
                                 $heading_file_name, $text_position,
                                 $text_file_name)
                or &fpw_abort($fpwword2, "add_entry($word)");
        }

        my $ndx = 0;
        for my $entry ('Subject', 'Keywords', 'URI',
                       'Date', 'From', 'To',
                       'Newsgroups', 'Summary'){
            my $field = "\L$entry";
            my $value = $list{'field'}{$field};
            if (defined $value && length $value){
                if (!$ndx){
                    #Фν񤭹
                    $fpwheading->add_text($value) or &fpw_abort($fpwheading);

                    $fpwtext->add_keyword_start() or &fpw_abort($fpwtext);
                    $fpwtext->add_text($value) or &fpw_abort($fpwtext);
                    $fpwtext->add_keyword_end() or &fpw_abort($fpwtext);
                    $fpwtext->add_newline() or &fpw_abort($fpwtext);
                }elsif ($entry eq 'Summary'){
                    $fpwtext->add_newline() or &fpw_abort($fpwtext);
                    $fpwtext->add_indent_level(2) or &fpw_abort($fpwtext);
                    $fpwtext->add_text($value) or &fpw_abort($fpwtext);
                }else{
                    $fpwtext->add_text("$entry: $value") or &fpw_abort($fpwtext);
                }
                $fpwtext->add_newline() or &fpw_abort($fpwtext);
                ++$ndx;
            }
        }
        print "$file_no/$size\n" unless ++$file_no % 10;
    }
}

## 񤭹ѤκȥեĤ롣
finalize_fpwparser('text'    => \$fpwtext,
		   'heading' => \$fpwheading,
		   'word2'   => \$fpwword2);


sub fpw_abort{
    my $fpwhandle = shift;
    my $str = "$PROGRAM_NAME: ";
    $str .= join(' ', @_) . ':' if @_;
    $str .= $fpwhandle->error_message();
    die $str . "\n";
}
