#! /usr/local/bin/perl5 -w
# -*- Perl -*-
#
# nmzcat.pl - by furukawa@tcp-ip.or.jp
#

push(@INC, "/usr/local/share/namazu/pl");
{
    my($tmp) = $0;
    $tmp = "./$tmp" if $tmp !~ /[\/\\]/;
    while ($tmp =~ /^(.*[\/\\])/){
        unshift(@INC, $1);
        last if !-l $tmp;
        $tmp = $1 . $tmp if ($tmp = readlink($tmp)) !~ /^\//;
    }
}
require 'nmzidx.pl';

$| = 1;

my $opt_fast = 0;
my $opt_all = 0;

while (@ARGV && $ARGV[0] =~ s/^\-//){
    my $argv = shift(@ARGV);
    while ($argv =~ s/^(.)//){
        my $opt = $1;
        $opt_all = 1 if $opt eq 'a';
        $opt_fast = 1 if $opt eq 'f';
        $opt_jp = 1 if $opt eq 'j';
        &usage, exit if $opt eq 'h';
    }
}

unshift(@ARGV, '.') if @ARGV == 1;

if (@ARGV >= 2){
    my $dir = shift(@ARGV);
    my $nmz = new nmzidx($dir, 'r');

    my $pat = shift @ARGV;

    my $nmz_file = $nmz->open_flist;
    exit unless defined $nmz_file;

    my $catno;
    my $ndx = -1;
    my %list;
    while (defined $nmz_file->read(\%list)){
        ++$ndx;
        next if defined($pat) && $list{'r'} !~ /$pat/;

        print "$list{'r'}\n";
        print "  timestamp=$list{'t'}\n";
        for my $key (sort keys %{$list{'field'}}){
            print "  field.$key=$list{'field'}{$key}\n";
        }
        print "\n";
        $catno = $ndx;
        last;
    }
    exit unless defined $catno;

    my $word;
    my $nmz_word = $nmz->open_word;
    exit unless defined $nmz_word;

    while (defined $nmz_word->read(\$word, \%list)){
        next if $opt_jp && $word !~ /[\x80-\xff]/;
        for my $fileno (keys %list){
            next if $catno != $fileno;
            print "$word score=$list{$fileno}\n";
            last;
        }
    }

    $nmz->close;
}

sub usage{
    print(  "Usage: nmzcat.pl [options] <dir> <path_pattern>\n"
          . "  -h     show this help and exit.\n"
          );
}
